PRO airs

cbar_btvalue=[200,320]
;------------------------
;-----Open AIRS Data
;------------------------
pick_airs = dialog_pickfile(title='Choose AIRS data set')
read_swath_l1_airs,pick_airs,numfp,numline,tai,lat,lon,rad,solzen,freq
lat=float(lat)
lon=float(lon)

;--------------------------------
;-------Eliminate bad sensors
;--------------------------------
print, '*******************************************************'
print, 'Default AIRS Channel Property file is most current.'
print, 'Choose a different file if you have a file that better '
print, 'fits the time period of the AIRS data.'
print, '*******************************************************'
pick_prop = dialog_pickfile(title='Choose AIRS Channel Properties File',filter='chan_prop.2003.01.10.v6.6.7.anc')
restore,'airschanproptemplate.sav'
airsdata=read_ascii(pick_prop,template=airschanprop_template)
result=where(airsdata.field13[*] ne 1,result_num)
cor_rad=fltarr(result_num,90,135)
cor_freq=fltarr(result_num)
cor_freq=freq[result]
cor_rad=rad[result,*,*]
cor_freq_wavel=10000.0/cor_freq

continue='y'
while(continue eq 'y' or continue eq 'Y')do begin
;------------------------------
;-----Choose and read SRF file
;------------------------------
temp='  '
repeat begin
	pick_srf = dialog_pickfile(title='Choose SRF')
	;-----Convolve SRF and AIRS data
	nlines=0
	openr, lun, pick_srf, /get_lun
	while (not eof(lun)) do begin
		readf, lun, temp
		nlines = nlines + 1
	endwhile
	free_lun, lun
	data = fltarr(2,nlines)
	openr, lun, pick_srf, /get_lun
	readf, lun, data
	free_lun, lun
	in_srf = data[1,*]
	in_freq = data[0,*]
	center_freq=0.0
	center_freq=mean(in_freq)
	center_wavel=10000.0/center_freq
	if(center_freq le cor_freq[0] or center_freq ge cor_freq[result_num-1]) then begin
		print, '*******************************************************'
		print, 'The selected SRF does not fall within AIRS data range.'
		print, 'Please choose another SRF file.'
		print, '*******************************************************'
	endif
	if(center_freq le 1215.0 and center_freq ge 1140.0) then begin
		print, '*******************************************************'
		print, 'You have encountered a large gap in the AIRS data set.'
		print, 'Please choose another SRF file.'
		print, '*******************************************************'
		center_freq=1.0
	endif
endrep until(center_freq ge cor_freq[0] $
	     and center_freq le cor_freq[result_num-1])

adjust_srf=' '
print, 'Adjust SRF Y for yes, N for no?'
read, adjust_srf
;-------------------------------------
;-----Alter SRF Code
;-------------------------------------
if(adjust_srf eq 'y' or adjust_srf eq 'Y') then begin
        ;print, 'nlines', nlines
	result=where(in_srf ge 0.50,count)
	in_lowhm=in_freq[result[0]]
	in_hihm=in_freq[result[count-1]]
	in_lowbnd=in_freq[0]
	in_hibnd=in_freq[nlines-1]
	del_wl=(in_hibnd - in_lowbnd)/(nlines-1)

	inc_lowhm=0.0
	inc_hihm=0.0
	print, 'Enter the # of wavenums to adjust the lowHM'
	print, 'Positive for larger wavenumber, negative for smaller wavenumber'
	read, inc_lowhm
	print, 'Enter the # of wavenums to adjust the hiHM'
	print, 'Positive for larger wavenumber, negative for smaller wavenumber'
	read, inc_hihm
	new_lowhm=in_lowhm+inc_lowhm
	new_hihm=in_hihm+inc_hihm
	print,new_lowhm,new_hihm

	dlam_lowhm=(in_lowhm - new_lowhm)
	dlam_hihm=(new_hihm - in_hihm)
	new_lowbnd=(in_lowbnd-dlam_lowhm)
	new_hibnd=(in_hibnd+dlam_hihm)
	new_nlines=((new_hibnd - new_lowbnd)/del_wl)+1
	new_freq=findgen(new_nlines)*del_wl+new_lowbnd
	num=n_elements(new_freq)
	new_freq2=fltarr(1,num)
	new_freq2[0,*]=new_freq
	new_freq=new_freq2
	new_srf=congrid(in_srf,1,new_nlines)
;-------------------------------------
;--------Interpolate SRF to fit data
;-------------------------------------

wavenum_min = 0.0
wavenum_max = 0.0
wavenum_min = new_freq[0]
wavenum_max = new_freq[new_nlines-1]
;-------Determine wavelengths to be used
result=where((cor_freq ge wavenum_min) and (cor_freq le wavenum_max))
result_num_srf = n_elements(result)
time = systime()
new_srf= congrid(new_srf[0,*],1,result_num_srf,/cubic)
new_freq=congrid(new_freq[0,*],1,result_num_srf,/cubic)
tot_final=fltarr(1,90,135)
avg_final=fltarr(1,90,135)
for k=0,result_num_srf-1 do begin
	for ii=0,89 do begin
		for jj=0,134 do begin	
			tot_final[0,ii,jj]=tot_final[0,ii,jj]+(cor_rad[result[k],ii,jj]*new_srf[k])
		endfor
	endfor
endfor
tot_final=tot_final/(total(new_srf))
endif else begin
;-----------------------------------

;-------------------------------------
;--------Interpolate SRF to fit data
;-------------------------------------

wavenum_min = 0.0
wavenum_max = 0.0
wavenum_min = in_freq[0]
wavenum_max = in_freq[nlines-1]
;-------Determine wavelengths to be used
result=where((cor_freq ge wavenum_min) and (cor_freq le wavenum_max))
result_num_srf = n_elements(result)
time = systime()
new_srf=congrid(in_srf[0,*],1,result_num_srf,/cubic)
new_freq=congrid(in_freq[0,*],1,result_num_srf,/cubic)
tot_final=fltarr(1,90,135)
avg_final=fltarr(1,90,135)
for k=0,result_num_srf-1 do begin
	for ii=0,89 do begin
		for jj=0,134 do begin	
			tot_final[0,ii,jj]=tot_final[0,ii,jj]+(cor_rad[result[k],ii,jj]*new_srf[k])
		endfor
	endfor
endfor
tot_final=tot_final/(total(new_srf))
endelse
;----------------------------------------------------------
;-----Determine if user wants brightness temp or radiance
;----------------------------------------------------------
selection=' '
repeat begin
	print, '*******************************************************'
	print, 'Do you want to work with radiance or brightness temperature?'
	print, 'Type RAD for radiance or BT for brightness temperature: '
	read, selection
	print, '*******************************************************'
endrep until (selection eq 'RAD' $
	or selection eq 'rad' $
	or selection eq 'BT' $
	or selection eq 'bt')
	
if (selection eq 'BT' or selection eq 'bt') then begin

;---------------------
;-----Call eff_wn
;---------------------
	hal_con=eff_wn(pick_srf,center_freq)

;----------------------------------------------
;---Compute BT using Hal's Planck Constants
;----------------------------------------------
	bt=fltarr(1,90,135)
	for i=0,89 do begin
		for j=0,134 do begin
			bt[0,i,j]=(hal_con[1]/alog(hal_con[0]/tot_final[0,i,j]+1.0)-hal_con[2])/hal_con[3]
		endfor
	endfor
endif

;-----------------------------------------------------
;------Write rad/bt, lat, lon to binary file
;-----------------------------------------------------
save=' '
repeat begin
	print, '*******************************************************'
	print, 'Do you want to save the data in binary format?'
	print, 'Enter Y for yes or N for no: '
	read, save
	print, '*******************************************************'
endrep until (save eq 'Y' $
	or save eq 'y' $
	or save eq 'N' $
	or save eq 'n')


if(save eq 'Y' or save eq 'y') then begin
pick_write=dialog_pickfile(title='Select file name to save binary data')
	openw, lun, pick_write, /get_lun
	if(selection eq 'BT' or selection eq 'bt') then begin
		writeu, lun, bt
	endif else begin	
		writeu, lun, tot_final
	endelse

	writeu, lun, lat
	writeu, lun, lon
	free_lun, lun
	print, '*******************************************************'
	print, 'Data written to file ', pick_write
	print, 'Data written with following format with no headers: '
	print, 'Radiance or Brightness Temp'
	print, 'Latitude'
	print, 'Longitude'
	print, '*******************************************************'

endif

;---------------------
;----Make Image
;---------------------
if(selection eq 'BT' or selection eq 'bt') then begin
	image_data=bt
endif else begin
	image_data=tot_final
endelse

window, /free, xsize=360,ysize=540
device, decomposed=0
blank_color=2
back_color=0
text_color=3
loadct, 13
stretch,4,!d.table_size-1,0.5
loadct, 0, ncolors=4,bottom=0
erase,color=back_color
tvlct,r,g,b,/GET
min_v=min(image_data)
max_v=max(image_data)
if(selection eq 'bt' or selection eq 'BT') then begin
	image=bytscl(image_data,cbar_btvalue[0],cbar_btvalue[1],TOP=!D.TABLE_SIZE-5)+4B
endif else begin
	     if(center_wavel lt 4.50) then begin
			image=bytscl(image_data,0,4,TOP=!D.TABLE_SIZE-5)+4B
    	     endif else begin
     			image=bytscl(image_data,10,170,TOP=!D.TABLE_SIZE-5)+4B
             endelse

endelse
lat2=congrid(lat,360,540,interp=1)
lon2=congrid(lon,360,540,interp=1)
image=congrid(image,1,360,540)
imagemap, image, lat2, lon2,Range=[4,!D.TABLE_SIZE-1],Position=[0.01,0.10,0.99,0.99],/noerase,missing=blank_color,/noborder
map_continents, /countries, /coasts,/hires, color=text_color

;----------------------------
;----Call Color Bar
;----------------------------
if(selection eq 'BT' or selection eq 'bt') then begin
	label=+string(center_wavel,format='(f4.1)')+string(' um Band, Brightness Temp  UW/CIMSS')
endif else begin
	label=+string(center_wavel,format='(f4.1)')+string(' um Band, Radiance  UW/CIMSS')
endelse
    print, 'min ', min_v, '  max ', max_v
if(selection eq 'BT' or selection eq 'bt') then begin
    cbar,0.2,0.07,[cbar_btvalue[0],cbar_btvalue[1]],[4,!d.table_size-1],$
     20,0,xsize=0.50,ysize=0.025,$
     label=label, $
     charsize=1.0,charthick=0.75,tcolor=text_color
endif else begin
     if(center_wavel lt 4.50) then begin
	     cbar,0.2,0.07,[0,4],[4,!d.table_size-1],$
	     2,0,xsize=0.50,ysize=0.025,$
	     label=label, $
	     charsize=1.0,charthick=0.75,tcolor=text_color
     endif else begin
     	     cbar,0.2,0.07,[10,170],[4,!d.table_size-1],$
	     40,0,xsize=0.50,ysize=0.025,$
	     label=label, $
	     charsize=1.0,charthick=0.75,tcolor=text_color
     endelse
endelse

;------------------------------------------
;---Save plot
;---Call saveimage by Liam Gumley
;------------------------------------------

save_choice=' '
repeat begin
	print, '*******************************************************'
	print, 'Do you want to save this plot as a .PNG?'
	print, 'Type Y for yes or N for no: '
	read, save_choice
	print, '*******************************************************'
endrep until (save_choice eq 'Y' $
	or save_choice eq 'y' $
	or save_choice eq 'n' $
	or save_choice eq 'N')
	
if(save_choice eq 'Y' or save_choice eq 'y') then begin
pick_name=dialog_pickfile(title='Select file name to save .PNG')
	saveimage, pick_name, /png
endif

if(!d.window ne -1) then begin
	wdelete, !d.window
endif

print, '*******************************************************'
print, 'Make another plot? Press Y for yes.'
read, continue
print, '*******************************************************'
endwhile

END
