PRO nasti

cbar_btvalue=[200,320]
;------------------------
;-----Open NASTI Data
;------------------------
sections=' '
repeat begin
	print, '*******************************************************'
	print, 'Is the NAST-I flight in the 3 original netCDF spectral sections?'
	print, 'Type Y for yes or N for no: '
	read, sections
	print, '*******************************************************'
endrep until (sections eq 'y' $
	or sections eq 'Y' $
	or sections eq 'n' $
	or sections eq 'N')

if (sections eq 'Y' or sections eq 'y') then begin

	nasti_to_binary
endif


pick_nasti=dialog_pickfile(title='Pick NASTI binary file.')
openr, lun, pick_nasti, /get_lun
n_freq=0L
length=0L
readu, lun, n_freq
readu, lun, length
rad=fltarr(n_freq,length)
freq=fltarr(n_freq)
lat=fltarr(length)
lon=fltarr(length)
readu, lun, rad
readu, lun, freq
readu, lun, lat
readu, lun, lon
free_lun, lun
nasti_lines=length/13
rad=REFORM(rad,n_freq,13,nasti_lines)
lat=REFORM(lat,13,nasti_lines)
lon=REFORM(lon,13,nasti_lines)

;print, min(freq), max(freq)

continue='y'
while(continue eq 'y' or continue eq 'Y')do begin
;------------------------------
;-----Choose and read SRF file
;------------------------------
temp='  '

repeat begin
	pick_srf = dialog_pickfile(title='Choose SRF')
	;-----Convolve SRF and NASTI data
	nlines=0
	openr, lun, pick_srf, /get_lun
	while (not eof(lun)) do begin
		readf, lun, temp
		nlines = nlines + 1
	endwhile
	free_lun, lun
	data = fltarr(2,nlines)
	openr, lun, pick_srf, /get_lun
	readf, lun, data
	free_lun, lun
	in_srf = data[1,*]
	in_freq = data[0,*]
	center_freq=mean(in_freq)
	if(center_freq le min(freq) or center_freq ge max(freq)) then begin
		print, '*******************************************************'
		print, 'The selected SRF does not fall within NASTI data range.'
		print, 'Please choose another SRF file.'
		print, '*******************************************************'
	endif
endrep until(center_freq ge min(freq) $
	     and center_freq le max(freq))

;------------------------------------------------------
;-----Determine if subsection of flight is desired
;------------------------------------------------------
section=' '
repeat begin
	print, '*******************************************************'
	print, 'Do you want to use a spatial subsection the NASTI data set?
	print, 'Type Y for yes and N for no.'
	read, section
	print, '*******************************************************'
endrep until (section eq 'Y' $
		or section eq 'y' $
		or section eq 'N' $
		or section eq 'n')
if(section eq 'Y' or section eq 'y') then begin
	low=0
	hi=0
	print, '*******************************************************'
	print, 'Enter the low line number of the desired NASTI spatial subsection.'
	print, 'Low line number must be greater/equal to 0 and less than high end.'
	read, low
	print, 'Enter the high line number of the desired NASTI spatial subsection.'
	print, 'High line number must be < = than '+string(nasti_lines, format='(i4)')
	read, hi
	print, '*******************************************************'
	nasti_size=(hi-low)
endif else begin
	nasti_size=nasti_lines
endelse	

adjust_srf=' '
print, 'Adjust SRF Y for yes, N for no?'
read, adjust_srf
;-------------------------------------
;-----Alter SRF Code
;-------------------------------------
if(adjust_srf eq 'y' or adjust_srf eq 'Y') then begin
        ;print, 'nlines', nlines
	result=where(in_srf ge 0.50,count)
	in_lowhm=in_freq[result[0]]
	in_hihm=in_freq[result[count-1]]
	in_lowbnd=in_freq[0]
	in_hibnd=in_freq[nlines-1]
	del_wl=(in_hibnd - in_lowbnd)/(nlines-1)

	inc_lowhm=0.0
	inc_hihm=0.0
	print, 'Enter the # of wavenums to adjust the lowHM'
	print, 'Positive for larger wavenumber, negative for smaller wavenumber'
	read, inc_lowhm
	print, 'Enter the # of wavenums to adjust the hiHM'
	print, 'Positive for larger wavenumber, negative for smaller wavenumber'
	read, inc_hihm
	new_lowhm=in_lowhm+inc_lowhm
	new_hihm=in_hihm+inc_hihm
	dlam_lowhm=(in_lowhm - new_lowhm)
	dlam_hihm=(new_hihm - in_hihm)
	new_lowbnd=(in_lowbnd-dlam_lowhm)
	new_hibnd=(in_hibnd+dlam_hihm)
	new_nlines=((new_hibnd - new_lowbnd)/del_wl)+1
	new_freq=findgen(new_nlines)*del_wl+new_lowbnd
	num=n_elements(new_freq)
	new_freq2=fltarr(1,num)
	new_freq2[0,*]=new_freq
	new_freq=new_freq2
	new_srf=congrid(in_srf,1,new_nlines)
;-------------------------------------
;--------Interpolate SRF to fit data
;-------------------------------------
wavenum_min = 0.0
wavenum_max = 0.0
wavenum_min = new_freq[0]
wavenum_max = new_freq[new_nlines-1]
;-------Determine wavelengths to be used
result=where((freq ge wavenum_min) and (freq le wavenum_max))
result_num_srf = n_elements(result)
new_srf=congrid(new_srf[0,*],1,result_num_srf)
new_freq=congrid(new_freq[0,*],1,result_num_srf)
center_f=mean(new_freq)
center_wavel=10000/center_f
tot_final=fltarr(1,13,nasti_size)
avg_final=fltarr(1,13,nasti_size)

for k=0,result_num_srf-1 do begin
	for ii=0,12 do begin
		if(section eq 'Y' or section eq 'y') then begin
			for jj=0,nasti_size-1 do begin	
				tot_final[0,ii,jj]=tot_final[0,ii,jj]+(rad[result[k],ii,jj+low]*new_srf[k])
			endfor
		endif else begin
			for jj=0,nasti_size-1 do begin	
				tot_final[0,ii,jj]=tot_final[0,ii,jj]+(rad[result[k],ii,jj]*new_srf[k])
			endfor
		endelse
	endfor
endfor
tot_final=tot_final/(total(new_srf))
endif else begin
;-------------------------------------
;--------Interpolate SRF to fit data
;-------------------------------------
wavenum_min = 0.0
wavenum_max = 0.0
wavenum_min = in_freq[0]
wavenum_max = in_freq[nlines-1]
;-------Determine wavelengths to be used
result=where((freq ge wavenum_min) and (freq le wavenum_max))
result_num_srf = n_elements(result)
new_srf=congrid(in_srf[0,*],1,result_num_srf)
new_freq=congrid(in_freq[0,*],1,result_num_srf)
center_f=mean(new_freq)
center_wavel=10000/center_f
tot_final=fltarr(1,13,nasti_size)
avg_final=fltarr(1,13,nasti_size)
for k=0,result_num_srf-1 do begin
	for ii=0,12 do begin
		if(section eq 'Y' or section eq 'y') then begin
			for jj=0,nasti_size-1 do begin	
				tot_final[0,ii,jj]=tot_final[0,ii,jj]+(rad[result[k],ii,jj+low]*new_srf[k])
			endfor
		endif else begin
			for jj=0,nasti_size-1 do begin	
				tot_final[0,ii,jj]=tot_final[0,ii,jj]+(rad[result[k],ii,jj]*new_srf[k])
			endfor
		endelse
	endfor
endfor
tot_final=tot_final/(total(new_srf))
endelse


;----------------------------------------------------------
;-----Determine if user wants brightness temp or radiance
;----------------------------------------------------------
selection=' '
repeat begin
	print, '*******************************************************'
	print, 'Do you want to work with radiance or brightness temperature?'
	print, 'Type RAD for radiance or BT for brightness temperature: '
	read, selection
	print, '*******************************************************'
endrep until (selection eq 'RAD' $
	or selection eq 'rad' $
	or selection eq 'BT' $
	or selection eq 'bt')
	
if (selection eq 'BT' or selection eq 'bt') then begin

;---------------------
;-----Call eff_wn
;---------------------
	hal_con=eff_wn(pick_srf,center_freq)

;----------------------------------------------
;---Compute BT using Hal's Planck Constants
;----------------------------------------------
	bt=fltarr(1,13,nasti_size)
	for i=0,12 do begin
		for j=0,nasti_size-1 do begin
			bt[0,i,j]=(hal_con[1]/alog(hal_con[0]/tot_final[0,i,j]+1.0)-hal_con[2])/hal_con[3]

		endfor
	endfor
endif


sub_rad=fltarr(1,13,nasti_size)
sub_lat=fltarr(13,nasti_size)
sub_lon=fltarr(13,nasti_size)
for j=0,12 do begin
	for i=0,nasti_size-1 do begin
		if(selection eq 'BT' or selection eq 'bt') then begin
			sub_rad[0,j,i]=bt[0,j,i]
		endif else begin
			sub_rad[0,j,i]=tot_final[0,j,i]
		endelse
		sub_lat[j,i]=lat[j,i]
		sub_lon[j,i]=lon[j,i]
	endfor
endfor
;-----------------------------------------------------
;------Write rad/bt, lat, lon to binary file
;-----------------------------------------------------
save=' '
repeat begin
	print, '*******************************************************'
	print, 'Do you want to save the data in binary format?'
	print, 'Enter Y for yes or N for no: '
	read, save
	print, '*******************************************************'
endrep until (save eq 'Y' $
	or save eq 'y' $
	or save eq 'N' $
	or save eq 'n')

if(save eq 'Y' or save eq 'y') then begin
pick_write=dialog_pickfile(title='Select file name to save binary data')
	openw, lun, pick_write, /get_lun
	if(selection eq 'BT' or selection eq 'bt') then begin
		writeu, lun, bt
	endif else begin	
		writeu, lun, tot_final
	endelse
	writeu,lun, sub_lat
	writeu,lun, sub_lon
	free_lun, lun
	print, '*******************************************************'
	print, 'Data written to file ', pick_write
	print, 'Data written in following format with no headers: '
	print, 'Radiance or Brightness Temp'
	print, 'Latitude'
	print, 'Longitude'
	print, '*******************************************************'

endif


;---------------------
;----Make Image
;---------------------
if(selection eq 'BT' or selection eq 'bt') then begin
	image_data=bt
endif else begin
	image_data=tot_final
endelse
window, /free, xsize=360,ysize=540
device, decomposed=0
blank_color=2
back_color=0
text_color=3
loadct, 13
stretch,4,!d.table_size-1,0.5
loadct, 0, ncolors=4,bottom=0
erase,color=back_color
tvlct,r,g,b,/GET
min_v=min(image_data)
max_v=max(image_data)
if(selection eq 'bt' or selection eq 'BT') then begin
	image=bytscl(image_data,cbar_btvalue[0],cbar_btvalue[1],TOP=!D.TABLE_SIZE-5)+4B
endif else begin
	     if(center_wavel lt 4.50) then begin
			image=bytscl(image_data,0,4,TOP=!D.TABLE_SIZE-5)+4B
    	     endif else begin
     			image=bytscl(image_data,10,170,TOP=!D.TABLE_SIZE-5)+4B
             endelse

endelse
image=congrid(image,1,104,808)
sub_lat=congrid(sub_lat,104,808,interp=1)
sub_lon=congrid(sub_lon,104,808,interp=1)
imagemap, image, sub_lat, sub_lon,Position=[0.01,0.10,0.99,0.99],/noerase,Range=[4,!d.table_size-1],missing=blank_color,/noborder
map_continents, /countries, /coasts,/hires, /usa,color=text_color

;----------------------------
;----Call Color Bar
;----------------------------
if(selection eq 'BT' or selection eq 'bt') then begin
	label=+string(center_wavel,format='(f4.1)')+string(' um Band, Brightness Temp  UW/CIMSS')
endif else begin
	label=+string(center_wavel,format='(f4.1)')+string(' um Band, Radiance  UW/CIMSS')
endelse
    print, 'min ', min_v, '  max ', max_v
if(selection eq 'BT' or selection eq 'bt') then begin
    cbar,0.2,0.07,[cbar_btvalue[0],cbar_btvalue[1]],[4,!d.table_size-1],$
     20,0,xsize=0.50,ysize=0.025,$
     label=label, $
     charsize=1.0,charthick=0.75,tcolor=text_color
endif else begin
     if(center_wavel lt 4.50) then begin
	     cbar,0.2,0.07,[0,4],[4,!d.table_size-1],$
	     2,0,xsize=0.50,ysize=0.025,$
	     label=label, $
	     charsize=1.0,charthick=0.75,tcolor=text_color
     endif else begin
     	     cbar,0.2,0.07,[10,170],[4,!d.table_size-1],$
	     40,0,xsize=0.50,ysize=0.025,$
	     label=label, $
	     charsize=1.0,charthick=0.75,tcolor=text_color
     endelse
endelse

;------------------------------------------
;---Save plot
;---Call saveimage by Liam Gumley
;------------------------------------------
save_choice=' '
repeat begin
	print, '*******************************************************'
	print, 'Do you want to save this plot as a .PNG?'
	print, 'Type Y for yes or N for no: '
	read, save_choice
	print, '*******************************************************'
endrep until (save_choice eq 'Y' $
	or save_choice eq 'y' $
	or save_choice eq 'n' $
	or save_choice eq 'N')
	
if(save_choice eq 'Y' or save_choice eq 'y') then begin
pick_name=dialog_pickfile(title='Select file name to save .PNG')
	saveimage, pick_name, /png
endif

if(!d.window ne -1) then begin
	wdelete, !d.window
endif

print, '*******************************************************'
print, 'Make another plot? Press Y for yes.'
read, continue
print, '*******************************************************'
endwhile

END
